#import "RingBuffer+Enumerator.h"

#define BufferSize   16

/* Local Class */
@interface RingBufferEnumerator : NSEnumerator
{
    RingBuffer *ringBuffer;
    NSFastEnumerationState eState;
    id buf[BufferSize];
    unsigned long limit, count;
}
- (id)initWithRingBuffer:(RingBuffer *)obj;
@end

@implementation RingBufferEnumerator

- (id)initWithRingBuffer:(RingBuffer *)obj
{
    if ((self = [super init]) != nil) {
        ringBuffer = obj;
        limit = [ringBuffer countByEnumeratingWithState:&eState 
                    objects:buf count:BufferSize];
        count = 0;
    }
    return self;
}

- (id)nextObject
{
    id obj;
    if (limit == 0) return nil;
    obj = eState.itemsPtr[count++];
    if (count >= limit) {
        limit = [ringBuffer countByEnumeratingWithState:&eState 
                    objects:buf count:BufferSize];
        count = 0;
    }
    return obj;
}

- (NSUInteger)countByEnumeratingWithState:(NSFastEnumerationState *)state 
        objects:(id *)stackbuf count:(NSUInteger)len
{
    return [ringBuffer countByEnumeratingWithState:state
            objects:stackbuf count:len];
}

@end

@implementation RingBuffer (Enumerator)

- (NSEnumerator *)objectEnumerator
{
    return [[RingBufferEnumerator alloc] initWithRingBuffer:self];
}

@end
