/*** Copyright: OGIHARA Takeshi, March 2008 ***/

#import <Foundation/NSObject.h>
#import <Foundation/NSString.h>
#import <Foundation/NSGeometry.h>

@class NSWindow, NSNotification, NSUndoManager;

extern NSString *ShrinkAllNotification;
extern NSString *SizeDidChangeNotification;

@interface WinCtrl : NSObject
{
    NSString *filename;
    id docImage;
    NSSize originalSize;
    NSWindow *window;
    NSUndoManager *undoManager;
    double mag;
}

+ (void)initialize;
+ (BOOL)autoResize;
+ (void)setAutoResize:(BOOL)flag;
- (id)initWithFile:(NSString *)path;
- (NSString *)attributesOfImage;
- (void)shrink:(id)sender;

/* Delegate Messages */
- (BOOL)windowShouldClose:(id)sender;
- (NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)win;
@end
