/*** Copyright: OGIHARA Takeshi, May 2008 ***/

#import <Foundation/Foundation.h>
#import "UroRemotePiece.h"
#import "UroServer.h"
#import <signal.h>

static id piece;

static void trap_signal(int _)
{
    [piece terminate];
}

int main(int argc, char **argv)
{
    struct sigaction sa = { { 0 } };
    id pool = [[NSAutoreleasePool alloc] init];
    id ctrl = [NSConnection
            rootProxyForConnectionWithRegisteredName:ServerName host:@""];
    [ctrl setProtocolForProxy:@protocol(UroRemoteServices)];
    piece = [[UroRemotePiece alloc] initWithController:ctrl];
    sa.sa_handler = trap_signal;	// catch Unix Signal
    sa.sa_flags |= SA_RESTART;
    sigaction(SIGINT, &sa, NULL);
    if ([ctrl registerAsRemoteClient:piece]) // if registered successfully
        [[NSRunLoop currentRunLoop] run];
    [pool release];
    return 0;
}
